apiVersion: apps/v1
kind: Deployment
metadata:
  name: website
spec:
  selector:
    matchLabels:
      app: website
  template:
    metadata:
      labels:
        app: website
    spec:
      initContainers:
        # This container clones the desired git repo to the EmptyDir volume.
        - name: git-clone
          image: alpine/git # Any image with git will do
          args:
            - clone
            - --single-branch
            - --
            - https://gitlab.com/daniel-builds/school-projects/aliens-cheese.git # Your repo
            - /usr/share/nginx/html # Put it in the volume
          securityContext:
            runAsUser: 1 # Any non-root user will do. Match to the workload.
            allowPrivilegeEscalation: false
            readOnlyRootFilesystem: true
          volumeMounts:
            - name: website-volume
              mountPath: /usr/share/nginx/html
      containers:
        - name: website
          image: nginx:alpine
          ports:
            - containerPort: 80
          volumeMounts:
            - mountPath: /usr/share/nginx/html
              name: website-volume
      volumes:
        - name: website-volume
          emptyDir: {}
---
apiVersion: v1
kind: Service
metadata:
  name: website
  labels:
    app: website
spec:
  type: NodePort
  ports:
    - name: http
      port: 80
  selector:
    app: website
---
apiVersion: networking.k8s.io/v1
kind: Ingress
metadata:
  name: website-ingress
spec:
  rules:
      - host: alien-conspiracy.skarzhevskyy.com
        http:
          paths:
            - path: /
              pathType: Prefix
              backend:
                service:
                  name: website
                  port:
                    number: 80
